import Tkinter as T
from tkFileDialog   import askopenfilename, asksaveasfilename  
import sys

import threading
import os
import pprint


from generalized_multi import glue_rules as app
from widgets import *


def call_ar_extractor(cmd):

    for k,default in [('log_file', os.devnull), ('out_file', None)]:
        if cmd[k].strip() == "":
            cmd[k] = default
    print "Calling extractor with parameters"
    pprint.pprint(cmd)
    app.main(cmd['dataset'], cmd['minconf'], cmd['log_file'], cmd['out_file'],
             sort_by = cmd['sort_by'], ascending = cmd['ascending'],
             opportunistic = cmd['opportunistic'])
    print "Job completed"


def run_gui(job_runner, available_sort_by_strategies):

    gui = GUI(job_runner)

    gui.file_chooser_row("Dataset", askopenfilename , "dataset", ensure_string_is_not_empty,
                         "A Dataset must be specified")

    gui.entry_row("Min Conf", "minconf", float, "Minimum support must be a float")
    
    gui.file_chooser_row("Log on", asksaveasfilename , "log_file", str, "An error occurred")

    gui.file_chooser_row("Save output to", asksaveasfilename, 
                         "out_file", str, "An error occurred") 

    gui.alternatives_row("Sort by", available_sort_by_strategies,
                         "sort_by", str,
                         "Please select a field") 

    gui.ask_true_false_row("Ascending sorting", 
                           "ascending", bool, "An error occurred")

    gui.ask_true_false_row("Opportunistic itemsets", 
                           "opportunistic", bool, "An error occurred")


    gui.run()


def run(parser, options, args, available_sort_by_strategies):

    job_runner = JobRunner()
    worker = get_worker(job_runner.queue, call_ar_extractor)

    t = threading.Thread(target=run_gui, args=(job_runner, available_sort_by_strategies))

    t.start()
    worker()
