import Tkinter as T
from tkFileDialog   import askopenfilename, asksaveasfilename  
import sys

import threading
import os
import pprint


from generalized_multi import glue_itemsets as app
from widgets import *


def call_itemset_extractor(cmd):

    for k,default in [('log_file', os.devnull), ('gen_rules',None), ('out_file', None) ]:
        if cmd[k].strip() == "":
            cmd[k] = default
    print "Calling extractor with parameters"
    pprint.pprint(cmd)
    app.main(cmd['dataset'], cmd['minsup'], cmd['log_file'], cmd['gen_rules'], cmd['out_file'],
             candidate_generation_strategy = cmd['candidate_strategy'], 
             extraction_strategy = cmd['extraction_strategy'],
             optimize = 0, ensure_subsets = cmd['ensure_subsets'], 
             print_excluded_strategy = cmd['print_excluded_strategy'])
    print "Job completed"


def run_gui(job_runner, available_generation_strategies, 
            available_extraction_strategies, available_print_excluded_strategies):

    gui = GUI(job_runner)

    gui.file_chooser_row("Dataset", askopenfilename , "dataset", ensure_string_is_not_empty,
                         "A Dataset must be specified")

    gui.entry_row("Min Sup", "minsup", int, "Minimum support must be an integer")

    gui.file_chooser_row("Generalization rules",askopenfilename , "gen_rules", str, "An error occurred")
    
    gui.file_chooser_row("Log on", asksaveasfilename , "log_file", str, "An error occurred")
    
    gui.alternatives_row("Candidate generation strategy", available_generation_strategies,
                         "candidate_strategy", str,
                         "Please select a strategy for generating candidates") 

    gui.alternatives_row("Extraction strategy", available_extraction_strategies,
                         "extraction_strategy", str, 
                         "Please select a strategy for itemsets extraction")

    gui.file_chooser_row("Save output to", asksaveasfilename, 
                         "out_file", str, "An error occurred") 

    gui.ask_true_false_row("Ensure all subsets are included", 
                           "ensure_subsets", bool, "An error occurred")

    gui.alternatives_row("Exclusion set output format", available_print_excluded_strategies, 
                         "print_excluded_strategy", str,
                         "Please select a strategy for writing exclusion sets")

    gui.run()


def run(parser, options, args, available_generation_strategies, 
        available_extraction_strategies, available_print_excluded_strategies):

    job_runner = JobRunner()
    worker = get_worker(job_runner.queue, call_itemset_extractor)

    t = threading.Thread(target=run_gui, args=(job_runner, available_generation_strategies, 
                                               available_extraction_strategies, 
                                               available_print_excluded_strategies))

    t.start()
    worker()
